require 'cgi'
require 'open-uri'
require 'nokogiri'

# Slownik jezyka polskiego
module Sjp
  # Parser class
  class Parser
    attr_reader :word, :page, :html

    def initialize
      @word, @html, @page, @hash = '', '', nil, {}
    end

    def word=(text)
      @word = text
      @encoded_word = CGI.escape text
      self.html = open(path).read
      table
    end

    def exist?
      ![
        'słowo występuje tylko jako część innych haseł',
        'nie występuje w słowniku'
      ].include? status
    end

    def allowed?
      # TODO: tests for exist and allow
      # exist? && (status != 'niedopuszczalne w grach')
      status == 'dopuszczalne w grach '
    end

    def variety?
      @hash['odmienność:'] == 'tak'
    end

    def description
      @page.css('p')[3].text
    end

    def html=(value)
      @html = value
      @page = Nokogiri::HTML(@html)
    end

    private

    def host
      'http://sjp.pl/'
    end

    def path
      "#{host}#{@encoded_word}"
    end

    def status
      @page.search('p').first.text
    end

    def table
      @page.search('table tr').each do |row|
        key, value = row.search('th').text, row.search('td').text
        @hash[key] = value
      end
    end
  end
end
